{----------------------------------------------------------------------------}
{                                                                            }
{                        SUPER CORECTOR Version 2.1                          }
{                  Copyright (C) 1994-95 By The GodFather                    }
{                                                                            }
{----------------------------------------------------------------------------}
{                       Last corection - 17 July 1995                        }
{----------------------------------------------------------------------------}

{$M, 16380, 0, 655360}

USES
  Dos, Crt, Objects, Keybord, Screen, Windows, Buttons, Corector;

TYPE
  TSuper = OBJECT( TCorector )
    FUNCTION  GetText( Position: Integer ) : STRING; VIRTUAL;
    FUNCTION  Search( Key: Char ): Integer; VIRTUAL;
    PROCEDURE ShowProgramLogo; VIRTUAL;
    PROCEDURE StartCorect( Position: Integer ); VIRTUAL;
    PROCEDURE InitCollection;
    DESTRUCTOR Done; VIRTUAL;
  END;

  PGameInfo = ^TGameInfo;
  TGameInfo = OBJECT( TObject )
    Name: PString;
    Data: ARRAY[1..20] OF PString;
    Counter: Byte;
    CONSTRUCTOR Init( NewName : STRING;
                      NewData : ARRAY OF STRING;
                      NewCounter : byte);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PDataCollection = ^TDataCollection;
  TDataCollection = OBJECT( TSortedCollection )
    FUNCTION KeyOf( Item: Pointer ) : Pointer; VIRTUAL;
    FUNCTION Compare( Key1, Key2: Pointer ) : Integer; VIRTUAL;
  END;

{ Global variables }
VAR
  DataInfo : PDataCollection;
  AnEntry  : PGameInfo;
  I        : Word;

{-----------------------------------}
{ OBJECTS initialization procedures }
{-----------------------------------}
FUNCTION TDataCollection.KeyOf( Item: Pointer ) : Pointer;
BEGIN
  KeyOf := @PGameInfo( Item )^.Name;
END { TDataCollection.KeyOf };

{-----------------------------------}
FUNCTION TDataCollection.Compare( Key1, Key2: Pointer ) : Integer;
BEGIN
  IF PString( Key1^ )^ = PString( Key2^ )^ THEN
    Compare := 0
  ELSE
  IF PString( Key1^ )^ < PString( Key2^ )^ THEN
    Compare := -1
  ELSE
    Compare := 1;
END { TDataCollection.Compare };

{-----------------------------------}
CONSTRUCTOR TGameInfo.Init( NewName : STRING;
                          NewData : ARRAY OF STRING;
                          NewCounter : byte);
BEGIN
  Name := NewStr( NewName );
  FOR I := 0 TO NewCounter DO
   Data[I + 1] := NewStr( NewData[i] );
  Counter := NewCounter;
END { TGameInfo.Init };

{-----------------------------------}
DESTRUCTOR TGameInfo.Done;
BEGIN
  DisposeStr( Name );
  FOR I := 1 TO Counter + 1 DO DisposeStr( Data[I] );
END { TGameInfo.Done };
{------------------------------------------}
{ End of OBJECTS initialization procedures }
{------------------------------------------}

PROCEDURE TSuper.ShowProgramLogo;
BEGIN
  MkWin(9, 3, 64, 19, White, Blue, True, CyrSingle, '');
  Dec( TextAttr );
  Writeln;
  Writeln('               ');
  Writeln('                     ');
  Writeln('                       ');
  Writeln('                ');
  Writeln('                          ');
  Writeln('                      ');
  Writeln('           ');
  Writeln('       ');
  Writeln('          ');
  Writeln('    ');
  Writeln('                   ');
  Writeln('          ');
  Writeln('                ');
  Writeln('       ');
  Writeln('               ');
  Writeln('                   ' + ProgramVer +'  ');
  Write(  '                        ');
  FBox(34, 19, 49, 21, White, Red, CyrDouble );
  WriteBetween( 34, 49, 20, White, Red, ProgramVer);
  Pause;
  RmWin;
END { ProgramLogo };

PROCEDURE TSuper.StartCorect( Position: Integer );
VAR
  F: Byte;
  SLine: STRING;

  PROCEDURE FormatLine;
  CONST
    Search : STRING[14] = 'Search for  : ';
    Replace: STRING[14] = 'Replace with: ';
    SStr   : STRING[1] = '$';
    RStr   : STRING[1] = '^';

  VAR FI: Byte;

  BEGIN
    IF SLine[1] = '&' THEN SLine := '';
    FOR FI := 1 TO 2 DO
    BEGIN
      IF Pos(SStr, Sline) <> 0 THEN
      BEGIN
        Insert( Search, Sline, Pos(SStr, Sline));
        Delete( Sline, Pos(SStr, Sline), 1);
      END;
      IF Pos(RStr, Sline) <> 0 THEN
      BEGIN
        Insert( Replace, Sline, Pos(RStr, Sline));
        Delete( Sline, Pos(RStr, Sline), 1);
      END;
    END;
  END;

BEGIN
  AnEntry := DataInfo^.At( Position - 1 );
  MkWin(2, 3, 78, 21, White, 5, False, CyrDouble, '[   ]');
  Dec( TextAttr );
  WITH AnEntry^ DO
  BEGIN
    Writeln;
    WriteCStr(78, True, Name^);
    Writeln;
    FOR F := 1 TO Counter DO
    BEGIN
      IF F = 2 THEN Writeln;
      IF Data[F]^[1] = ' ' THEN Writeln;
      Sline := Data[F]^;
      FormatLine;
      WriteCStr(78, True, Sline);
      IF Data[F]^[1] = ' ' THEN Writeln;
    END;
    Pause;
    RmWin;
  END;
END;

PROCEDURE TSuper.InitCollection;
VAR
  DataFile: Text;
  FileName: STRING;
  NName: STRING;
  NData: ARRAY[1..20] OF STRING;
  NCount: Byte;

  PROCEDURE SetVariables;
  BEGIN
    NName := '';
    NCount := 1;
    FOR I := 1 TO 20 DO NData[i] := '';
  END;

  PROCEDURE GetStr(VAR S : STRING);
  BEGIN
    S := '';
    Readln(DataFile, S);
    FOR I:=1 TO Length(S) DO S[I] := Chr( Ord(S[I]) XOR $D5 XOR $4A );
  END;

  PROCEDURE GetCrk;
  BEGIN
    REPEAT
      GetStr( NData[NCount] );
      IF NData[NCount] = '-=-' THEN
      BEGIN
        Dec( NCount );
        Exit;
      END;
      Inc( NCount );
    UNTIL Eof( DataFile );
  END;

BEGIN
  FileName := 'GSUPER.DAT';
  Assign( DataFile, FileName );
  {$I-}
    Reset( DataFile );
  {$I+}
  IF (IOResult <> 0) THEN
  BEGIN
    FileName := FSearch(FileName, GetEnv('PATH'));
    Assign(DataFile, FileName);
    {$I-}
     Reset( DataFile );
    {$I+}
    IF (IOResult <> 0) OR (FileName = '') THEN
    BEGIN
      ClearText( 1, 1, 80, 25, LightGray, Black );
      FBox(17, 9, 67, 13, White, Red, Double);
      WriteBetween(17, 67, 11, Yellow, Red, 'Can''t find GSUPER.DAT');
      GotoXY( 1, 20 );
      Halt( 1 );
    END;
  END;
  DataInfo := New( PDataCollection, Init(1, 1) );
  REPEAT
    SetVariables;
    GetStr( NName );
    GetCrk;
    IF MaxAvail < 1024 THEN
    BEGIN
      Dispose(DataInfo, Done);
      Writeln;
      Writeln('Not Enough Memory !');
      Halt;
    END;
    DataInfo^.Insert( New( PGameInfo, Init( NName, NData, NCount )));
  UNTIL Eof( DataFile );
  MaxGames := DataInfo^.Count;
END;

FUNCTION TSuper.GetText( Position: Integer ) : STRING;
BEGIN
  AnEntry := DataInfo^.At( Position );
  GetText := AnEntry^.Name^;
END;

FUNCTION TSuper.Search( Key: Char ): Integer;
VAR
  Tmp     : Word;
  FoundIt : Boolean;
  TmpEntry: PGameInfo;

BEGIN
  FoundIt := False;
  FOR Tmp := 0 TO DataInfo^.Count - 1 DO
  BEGIN
    TmpEntry := DataInfo^.At( Tmp );
    IF Key = TmpEntry^.Name^[1] THEN
    BEGIN
      FoundIt := True;
      Break;
    END;
  END;
  IF FoundIt
    THEN Search := Tmp + 1
    ELSE Search := -1;
END;

DESTRUCTOR TSuper.Done;
BEGIN
  Dispose( DataInfo, Done );
END;

VAR
  Super: TSuper;

BEGIN
  Super.Init('SUPER CORECTOR', ' 2.1');
  Super.InitCollection;
  Super.Run;
END.